(function() {
	tpl.at = {};

	tpl.at.createData = function () {
		var acceptanceData = [
		// {title:"TIMOBXXXX", hasChild:true, level:"acceptance"},
		{title:"TIMOB5351", hasChild:true, level:"acceptance"},
		{title:"TIMOB5353", hasChild:true, level:"acceptance"},
		{title:"TIMOB5465", hasChild:true, level:"acceptance"}
		]

		return acceptanceData;
	};
	
	//
	// TIMOB-5353
	// iOS: In TiBase.h, "expected" and "was" Are Frequently Backwards
	//
	tpl.at.TIMOB5353 = function(_window)
	{
		var tabs = Ti.UI.createTabGroup();
		
		tabs.addTab(Ti.UI.createLabel());
		
		tabs.open();
		
		return _window();
	};

	//
	// iOS: A Tab Bar's Child's rightNavButton Can Get Placed on Parent
	//
	tpl.at.TIMOB5351 = function(_window){

		// iOS Specific
		if(Ti.Platform.name != "iPhone OS"){
			_window.add(tpl.ui.getSkipLabel());
			return _window;
		}

		var tabGroup = Ti.UI.createTabGroup();

		var outer = Ti.UI.createWindow({
		    title: 'I Am Outer',
		    rightNavButton: Ti.UI.createButton({ title: 'Open Middle' }),
		    backgroundColor: '#fff'
		});
		outer.add(Ti.UI.createLabel({ text: 'I Am Outer' }));
		var tab = Ti.UI.createTab({
		    window: outer
		});
		tabGroup.addTab(tab);

		outer.rightNavButton.addEventListener('click', function() {
		    var middle = Ti.UI.createWindow({
		        title: 'I Am Middle',
		        backgroundColor: '#fff'
		    });
		    var table = Ti.UI.createTableView({
		        data: [
		            { title: 'I Am Middle, Click to Open Inner' }
		        ]
		    });
		    table.addEventListener('click', function() {
		        var inner = Ti.UI.createWindow({
		            title: 'I Am Inner',
		            rightNavButton: Ti.UI.createButton({ title: 'Do Nothing' }),
		            backgroundColor: '#fff'
		        });
		        inner.add(Ti.UI.createLabel({ text: 'I Am Inner' }));
		        tab.open(inner);
		    });
		    middle.add(table);
		    tab.open(middle);
		});

		_window.add(tabGroup);

		tabGroup.open();

		return _window;
	};

	//
	// TIMOB-5465
	// iOS: Tapping Tab Orphans Windows on Tab's Stack
	//
	tpl.at.TIMOB5465 = function(_window)
	{
		// iOS Specific
		if(Ti.Platform.name != "iPhone OS")
		{
			_window.add(tpl.ui.getSkipLabel());
			return _window;
		}

		var tabGroup = Ti.UI.createTabGroup();

		var outer = Ti.UI.createWindow({
			    title: 'I Am Parent',
				rightNavButton: Ti.UI.createButton({ title: 'S1: Touch Me' })
		});

		var tab = Ti.UI.createTab({
		    window: outer, title: 'S2: Touch Me'
		});

		tabGroup.addTab(tab);

		outer.rightNavButton.addEventListener('click', function() {
		    openWindowOnStack(0);
		});

		function openWindowOnStack(i)
		{
		    var win = Ti.UI.createWindow({
		        title: 'I Am ' + i
		    });

		    win.addEventListener('open', function() {
		        Ti.API.info('opened ' + i + '!');
		        if (i < 4) {
		            openWindowOnStack(i + 1);
		        }
		    });

		    win.addEventListener('close', function() {
		        Ti.API.info('closed ' + i + '!');
		    });

		    tab.open(win);
		}

		_window.add(tabGroup);
		tabGroup.open();
		_window.fullscreen = true;
		return _window;
	}
})();